export default class TextTrackParse extends BasePlugin {
    /**
     * @type ITextTrackConfig
     */
    static get defaultConfig(): ITextTrackConfig;
    _updateCallback: any;
    /**
     * 初始化外挂字幕
     * @param {number} defaultIndex
     */
    _initExtSubTitle(defaultIndex: number): void;
    subTitles: any;
    show(): void;
    _onOff: () => void;
    _onChange: (data: any) => void;
    _onUpdate: (text: any) => void;
    _onListReset: (data: any) => void;
    getSubTitleIndex(list: any, subtitle?: {
        id: string;
        language: string;
    }): number;
    /**
     *
     * @param { string | Array<SubTitleItem> } list
     * @param {} updateCallback 字幕更新的回调
     * @param { boolean } [needRemove] 是否移除原来的字幕
     */
    updateSubtitles(list: string | Array<SubTitleItem>, updateCallback: any, needRemove?: boolean): void;
    updateList(data?: {}): void;
    curIndex: number;
    curItem: any;
    /**
     *
     * @param {{
     *   language?: string | number,
     *   id?: number | string,
     * }} subtitle
     * @returns
     */
    switchSubTitle(subtitle?: {
        language?: string | number;
        id?: number | string;
    }): void;
    /**
     * 关闭字幕
     */
    switchOffSubtitle(e: any): void;
    lastIndex: number;
    switchOnSubtitle(): void;
}
export type ListItem = {
    start: number;
    end: number;
    list: {
        [propName: string]: any;
        start: number;
        end: number;
        text: string[];
        index?: number;
    }[];
};
export type SubTitleItem = {
    language?: string | number;
    id?: number | string;
    isDefault?: boolean;
    text?: any;
    url?: string;
    stringContent?: string;
    list?: {
        [propName: string]: any;
        start: number;
        end: number;
        list: Array<ListItem>;
    }[];
};
export type ITextTrackConfig = {
    [propName: string]: any;
    position?: string;
    index?: number;
    list?: Array<SubTitleItem>;
    isDefaultOpen?: boolean;
    style?: {
        follow: boolean | null;
        mode?: 'stroke' | 'bg';
        followBottom?: number;
        fitVideo?: boolean;
        offsetBottom?: number;
        baseSizeX?: number;
        baseSizeY?: number;
        minSize?: number;
        minMobileSize?: number;
        line?: 'double' | 'single' | 'three';
        fontColor?: string;
    };
    closeText?: {
        text: string;
        iconText: string;
    };
    className?: string;
    hidePortrait?: boolean;
    isShowIcon?: boolean;
    updateMode?: 'live' | 'vod';
    renderMode?: 'normal';
    debugger?: boolean;
};
import BasePlugin from "../../plugin";
